Last Comment Bug 47159 - Support css3-speech (previously Aural Style Sheet) properties in getComputedStyle
: Support css3-speech (previously Aural Style Sheet) properties in getComputedS...
Status: NEW
: access, css2
Product: Core
Classification: Components
Component: CSS Parsing and Computation (show other bugs)
: Trunk
: All All
: P4 normal with 13 votes (vote)
: Future
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
http://www.w3.org/TR/css3-speech/
: 317340 (view as bug list)
Depends on: 43457
Blocks: 42417 css3test 70022 grouper
  Show dependency treegraph
 
Reported: 2000-08-01 03:54 PDT by Adrian
Modified: 2015-11-16 18:46 PST (History)
28 users (show)
roc: blocking1.9.2-
roc: wanted1.9.2-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Adrian 2000-08-01 03:54:40 PDT
Mozilla should have an option to voice read the web pages. CSS 2 has implemented 
 voice options. The voice-browsers standarts can be finded on W3C homepage.
Comment 1 James Green 2000-08-01 07:15:19 PDT
Suggest marking a duplicate of Bug #12952 since they're both up the same street.
Comment 2 Tomer Brisker 2000-08-01 07:19:46 PDT

*** This bug has been marked as a duplicate of 12952 ***
Comment 3 Asa Dotzler [:asa] 2000-08-01 12:01:23 PDT
verified dupe of bug 12952 -On the Windows platform, the browser does not expose
its UI and contents to
Microsoft Active Accessibility.  This means that a plethora of accessibility
aids (screen readers, magnifiers, etc.) will not work with Mozilla!
Comment 4 Aaron Leventhal 2000-09-21 16:28:33 PDT
This should not be a duplicate of 12952. Support for CSS 2 audio & braille 
isn't the same as supporting MSAA. Blazie Engineering will help implement 
support for CSS 2. Contact aaronl@chorus.net for details.
Comment 5 Asa Dotzler [:asa] 2000-09-21 16:58:19 PDT
over to Style system. aaron, is this a bug that you would like to own?
Comment 6 Aaron Leventhal 2000-09-22 12:19:55 PDT
Asa, I don't want to own it, but I will ask my co-worker to own it within the 
next couple of months. We will talk about it more during my December visit.
Comment 7 Pierre Saslawsky 2000-10-27 02:42:19 PDT
I think that the Aural properties are already parsed correctly but there is still 
a little bit of work to do to store them in the StyleContext.

It's not really a Style problem.  Most of the work has to be done in XPToolkit as 
described in bug 12952.
Comment 8 Aaron Leventhal 2000-12-19 21:59:41 PST
Pierre, excellent!
I've already got Mozilla speaking
(http://access-mozilla.sourceforge.net/status.php).
I just need to know how to get to the aural and braille css properties from C++
or Javascript. I'm chomping at the bit to be able to do that.
What do you mean about getting them stored in the style context? How do I do
that/ who can do that for me?
Comment 9 Aaron Leventhal 2000-12-20 03:42:27 PST
Here are the aural properties I need to get via getComputedStyle:
(from http://www.w3.org/TR/REC-CSS2/aural.html)
volume, speak, pause-before, pause-after, pause, cue-before, cue-after, cue,
play-during, azimuth, elevation, speech-rate, voice-family, pitch, pitch-range,
stress, richness, speak-punctuation, speak-numeral.

Also, there are @media types I'm interested, such as braille and embossed. How
do I use one of those in getComputedStyle?

Comment 10 Hixie (not reading bugmail) 2000-12-21 15:13:32 PST
Aarlon: See http://www.w3.org/TR/DOM-Level-2-Style
Comment 11 Hixie (not reading bugmail) 2001-02-12 16:49:41 PST
Netscape's standard compliance QA team reorganised itself once again, so taking 
remaining non-tables style bugs. Sorry about the spam. I tried to get this done 
directly at the database level, but apparently that is "not easy because of the 
shadow db", "plus it screws up the audit trail", so no can do...
Comment 12 Hixie (not reading bugmail) 2001-04-01 10:50:48 PDT
jst: Should this go to Harish?
Comment 13 Johnny Stenback (:jst, jst@mozilla.com) 2001-04-01 15:45:24 PDT
Indeed it should.

Aaron, when is this needed, the getComputedStyle() code is now in pretty good
shape (thanks to Harish) so adding support for this should be really easy. Let
us know how soon you need this.

Reassigning.
Comment 14 Marc Attinasi 2001-04-19 09:50:11 PDT
I just spoke to Harish about this bug. There is a fair amount of work to do in
the style system first: creating an Aural struct in the StyleContext, cascading
the aural properties, and mostly, testing that the value constraints,
inheritance and default values are all correct. I estimate this to be about a
week total, with 3 days for implementation and 2 for testing. Fortunately, we
have some excellent QA resources to help with the testing :)

Once the aural properties are in the style context, Harish's part should be
pretty easy...

CC'ing marek on this one for some help in prioritization. Pierre could certainly
do the style work as well as or better than I, but he is going on sabbatical
Real soon Now and may not be able to attend to this before leaving.
Comment 15 Pierre Saslawsky 2001-04-20 17:33:15 PDT
Please don't work in the implementation in nsStyleContext.cpp in the next 2 
weeks.  If I manage to check in my changes for bug 43457 before I leave, it will 
be much easier to support the aural properties.
Comment 16 Hixie (not reading bugmail) 2001-04-21 00:53:56 PDT
last I checked, we _do_ support them and cascade them. For every single element
in the entire DOM. In fact some people have suggested we might want to save
some memory and speed by cheating and disabling them. (Not that I approve, IMHO
since they are not used by most people, the properties shouldn't be taking any
time or space at all, unless someone uses them.)
Comment 17 Pierre Saslawsky 2001-04-23 06:01:28 PDT
These properties are parsed and there might be a minimum level of DOM support 
because they appear in the CSS declarations, but we certainly don't cascade them.  
They are not stored in the style context and the nsComputedDOMStyle functions for 
aural properties all return a 'non-supported' error.
Comment 18 Pierre Saslawsky 2001-04-23 15:05:58 PDT
Reassigned to myself but if I don't fix it before my sabbatical, please feel free 
to take it back.
Comment 19 Marc Attinasi 2001-04-23 15:31:44 PDT
Not sure if you noticed, Pierre, but this is on the Hot List
(http://bugzilla.mozilla.org/show_bug.cgi?id=75664) for Moz 0.9.
Comment 20 karnaze (gone) 2001-04-24 12:57:43 PDT
Moving to m0.9.
Comment 21 Pierre Saslawsky 2001-04-24 13:38:10 PDT
Set to P1/critical instead of P3/enhancement because it is on the Hot List.
Comment 22 chris hofmann 2001-04-24 15:51:00 PDT
figured out that 0.9 should be ok.
Comment 23 Peter Trudelle 2001-04-24 16:03:05 PDT
0.9.1 that is.  This bug is not actually on Marek's hot list, it was added as a
dependency of a tracking bug that is on Marek's list, by a mozilla contributor,
without any comment as to why it was added.  Thus, we have no indication so far
that this is needed for MSAA support.
Comment 24 Hixie (not reading bugmail) 2001-04-28 20:07:49 PDT
Pierre: I stand corrected.
Comment 25 Pierre Saslawsky 2001-04-29 18:40:44 PDT
If it's not on the HotList, I can mark it Future and dependent on bug 43457...
Comment 26 Fuzzy Gorilla 2002-03-03 16:47:51 PST
Shouldn't this also have keyword DOM2 attached (since it is one of the 2
remaining bugs blocking Bug 42417)?
Comment 27 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2002-06-19 21:05:22 PDT
Assigning pierre's remaining Style System-related bugs to myself.
Comment 28 Marek Z. Jeziorek 2002-09-13 09:45:56 PDT
batch: adding topembed per Gecko2 document
http://rocknroll.mcom.com/users/marek/publish/Gecko/Gecko2Tasks.html
Comment 29 Jaime Rodriguez, Jr. 2002-10-07 15:40:15 PDT
Changing from topembed, to embed, as this is not blocking a major embedding
customer.
Comment 30 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2002-10-23 18:19:16 PDT
FWIW, all aural stuff will most likely be heavily reworked in CSS3.
Comment 31 Michael Buckland 2002-10-25 14:41:49 PDT
Bulk adding topembed keyword.  Gecko/embedding needed.
Comment 32 saari (gone) 2002-10-28 15:20:59 PST
topembed-
Comment 33 Chris Nalls 2002-10-30 10:53:26 PST
Confirming Topembed-
Comment 34 Anne (:annevk) 2004-04-17 03:33:26 PDT
Is still needed? (Note that CSS 2.1 deprecates the media "aural" and "suggests"
using "speech" instead.)
Comment 35 Aaron Leventhal 2004-04-18 20:06:03 PDT
(In reply to comment #30)
> FWIW, all aural stuff will most likely be heavily reworked in CSS3.

Is CSS 3 still happening? I hear CSS work has ended.

Anyway, we will need this eventually, whether it's called speech or aural.
Comment 36 Anne (:annevk) 2004-04-18 22:27:06 PDT
> Is CSS 3 still happening? I hear CSS work has ended.

<http://www.w3.org/TR/css3-speech/>
Comment 37 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2005-11-21 14:05:46 PST
*** Bug 317340 has been marked as a duplicate of this bug. ***
Comment 38 David Bolter [:davidb] 2011-11-04 07:59:31 PDT
Status ping. Does anyone have implementing css3-speech on their TODO horizon?
Comment 39 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2011-11-04 09:58:57 PDT
I don't think so, but if I were aware that somebody had plans to use it, that might change.
Comment 40 Liam Morland 2011-11-04 10:33:39 PDT
The maker of the free screen reader Fire Vox would benefit greatly from having this bug fixed. See "Limitations of Firefox" here:

http://clc4tts.clcworld.net/css_technical.html
Comment 41 Mike Gifford 2014-05-04 07:22:57 PDT
This issue was opened in 2000.  Looking at http://css3test.com it still isn't fixed in FF 29.
Comment 42 Sebastian Zartner [:sebo] 2014-07-18 02:45:16 PDT
To make progress on this issue wouldn't it help to split it into smaller tasks? I.e. create an issue for each property?

Sebastian
Comment 43 Mike Gifford 2014-07-18 05:57:03 PDT
So a new issue for each of these:
    7.1. The ‘voice-volume’ property
    7.2. The ‘voice-balance’ property 
    8.1. The ‘speak’ property
    8.2. The ‘speak-as’ property 
    9.1. The ‘pause-before’ and ‘pause-after’ properties
    9.2. The ‘pause’ shorthand property
    9.3. Collapsing pauses 
    10.1. The ‘rest-before’ and ‘rest-after’ properties
    10.2. The ‘rest’ shorthand property 
    11.1. The ‘cue-before’ and ‘cue-after’ properties
    11.2. Relation between audio cues and speech synthesis volume levels
    11.3. The ‘cue’ shorthand property 
    12.1. The ‘voice-family’ property
    12.2. The ‘voice-rate’ property
    12.3. The ‘voice-pitch’ property
    12.4. The ‘voice-range’ property
    12.5. The ‘voice-stress’ property 
    13.1. The ‘voice-duration’ property 

Also important to think of how this will be used by assistive technology too http://community.nvda-project.org/ticket/4242

Note You need to log in before you can comment on or make changes to this bug.